#!/bin/bash
if [ "$#" -ne 1 ]; then
  echo "collect-times.sh <dir (e.g., arm)>"
  echo "This script inspects .correct files that are generated by 'make proofs'"
  echo "in the given architecture directory and collects all timing informations."
  exit 1
fi

s2n_bignum_arch=$1
cd $s2n_bignum_arch > /dev/null

num_correct_files=`find . -name "*.correct" | wc -l`
if [ $num_correct_files -eq 0 ]; then
  echo "No .correct file exists. Did you run 'make proofs'?"
  exit 1
fi
# grep must not detect anything including 'error' (case insensitive, '-i').
grep -r -i "Running time: " --include "*.correct"
